/* ǡڤġ no.2
 * 08/21 2000
 * shige
 * ausubstr.c
 *
 * $Id: ausubstr.c,v 1.2 2000-10-01 13:24:17+09 shige Exp $
 */
/* ausubstr (-v) (-o file) [start pos] ([length]) [file]
 */

#undef DEBUG1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sndio.h"

#define uns(s) ((unsigned char *)(s))
#define str4byte2x(s) (uns(s)[0]<<24|uns(s)[1]<<16|uns(s)[2]<<8|uns(s)[3])

int getarg(int argc,char **argv,int *start,int *length,int *verbose,
	   FILE **infile,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    Snddata  snddata0={
	0,	/* magic number */
	32, 	/* data  offset */
	0,  	/* data Ĺ */
	1,  	/* data format code (1= 8bit mu-low) */
	8000,	/* sampling rate */
	1,	/* cannel  */
	NULL
    };
    Snddata snd;
    int verbose;
    FILE *infile,*outfile;
    int start,length;
    int ret;
    
    snddata0.magic=str4byte2x(".snd");

    if((ret=getarg(argc,argv,&start,&length,&verbose,&infile,&outfile))<0)
      return -ret;

#ifdef DEBUG1
    printf("verbose=%d\n",verbose);
    printf("start  =%d\n",start);
    printf("length =%d\n",length);
    printf("(infile,outfile)=(%d,%d)\n",fileno(infile),fileno(outfile));
    return 0;
#endif
    /* main routine Ϥ*/
    if(getSndheader(infile,&snd)<0){
	if(verbose) fprintf(stderr,"Error: In getSndheader().\n");
	return 20;
    }
    if(chSndheader(&snd,&snddata0)<0){
	if(verbose)
	  fprintf(stderr,"Error: sound data is not -law 8kHz.\n");
	return 30;
    }
    if(verbose) fprintf(stderr,"total length=%d\n",snd.datalen);
    if(start>snd.datalen){
	if(verbose){
	    fprintf(stderr,"Error: Too late start position.\n");
	    fprintf(stderr,"It must be less than total length.\n");
	}
	return 0;
    }
    if(start+length>snd.datalen){
	if(verbose)
	  fprintf(stderr,"Warning: Specified length is too long.\n");
	length=snd.datalen-start;
    }
    snd.datalen=length;
    putallheader(outfile,&snd,1);
    putSnddata(infile,outfile,snd.hlen+start,length);
    return 0;
}

int getarg(int argc,char **argv,int *start,int *length,int *verbose,
	   FILE **infile,FILE **outfile)
{
    char *fname;

    *verbose=0;
    *outfile=stdout;
    *length=-1;

    while(--argc>0){
	if(**(++argv)=='-'){
	    if(*(++*argv)=='v') *verbose=1;
	    else if(**argv=='q') *verbose=0;
	    else if(**argv=='o'){
		if(*outfile!=stdout){ usage(0); return -1; }
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0){ usage(1); return -1; }
		    else argv++;
		}
		fname=*argv;
		if(!strcmp(fname,"-")) *outfile=stdout;
		else if((*outfile=fopen(fname,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",fname);
		    return -2;
		}
	    }
	    else if(**argv=='h' || **argv=='H' || **argv=='?'){
		usage(2); return -1;
	    }
	    else{ usage(3); return -2; }
	}
	else break;
    }
    if((*start=atoi(*argv))<0){ usage(4); return -3; }
    if(--argc>1){ 
	if((*length=atoi(*(++argv)))<=0){ usage(5); return -4; }
    }
    else argc++;
    if(--argc<=0 || argc>1){ usage(6); return -5; }
    fname=*(++argv);
    if(!strcmp(fname,"-")) *infile=stdin;
    else if((*infile=fopen(fname,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",fname);
	return -6;
    }
    return 0;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: ausubstr (-v) (-q) (-o [outfile]) [start] ([length]) [infile]",
	"   -v : Ĺ⡼",
	"   -q : quiet ⡼ (default)",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [start] : ϰ",
	"   [length]: ϺĹ (default: Ǹޤ)",
	"   [infile]: ϥե",
	" ",
	" [1] ϡϥե '-' ꤷɸϤˤʤ롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
