/* WAV file ôʬ
 * shige
 * 10/01 2000
 * wavio.c
 *
 * $Id: wavio.c,v 1.1 2000-10-01 13:17:12+09 shige Exp $
 */
#ifndef __WAVIO_C__
#define __WAVIO_C__

#include "wavio.h"

/* #define DEBUG1 */
/* #define DEBUG2 */

/* wav file  header μ */
int getWAVheader(FILE *file,WAVdata *wd)
{
    long int j;

    fseek(file,0,SEEK_SET);
    if(read4bytetolittlei(file,&j)<0 || j != sto4bytelittlei("RIFF"))
      return Err_readwavheader;
    fseek(file,4,SEEK_CUR);
    if(read4bytetolittlei(file,&j)<0 || j != sto4bytelittlei("WAVE"))
      return Err_readwavheader;
    /* format chunk θ */
    while(1){
	if(read4bytetolittlei(file,&j)<0) return Err_readwavheader;
	if(j != sto4bytelittlei("fmt ")){
	    /* skip */
	    if(read4bytetolittlei(file,&j)<0) return Err_readwavheader;
	    fseek(file,j,SEEK_CUR);
	}
	else break;
    }
    if(read4bytetolittlei(file,&j)<0 || j<16) return Err_readwavheader;
    if(read2bytetolittlei(file,&(wd->fmcode))<0) return Err_readwavheader;
    if(read2bytetolittlei(file,&(wd->channel))<0) return Err_readwavheader;
    if(read4bytetolittlei(file,&(wd->smplrate))<0) return Err_readwavheader;
    if(read4bytetolittlei(file,&(wd->bytepersec))<0) return Err_readwavheader;
    if(read2bytetolittlei(file,&(wd->blocksize))<0) return Err_readwavheader;
    if(read2bytetolittlei(file,&(wd->bitpersmpl))<0) return Err_readwavheader;
    if(j>16) fseek(file,j-16,SEEK_CUR);
    /* data chunk θ */
    while(1){
	if(read4bytetolittlei(file,&j)<0) return Err_readwavheader;
	if(j != sto4bytelittlei("data")){
	    /* skip */
	    if(read4bytetolittlei(file,&j)<0) return Err_readwavheader;
	    fseek(file,j,SEEK_CUR);
	}
	else break;
    }
    if(read4bytetolittlei(file,&(wd->datalen))<0) return Err_readwavheader;
    wd->hlen=ftell(file);
    return No_err;
}

/* WAV header  */
int chWAVheader(WAVdata *wd1,WAVdata *wd2)
{
    if(wd1->fmcode != wd2->fmcode) return Err_diffmcode;
    if(wd1->channel != wd2->channel) return Err_diffchannel;
    if(wd1->smplrate != wd2->smplrate) return Err_diffsmplrate;
    if(wd1->bytepersec != wd2->bytepersec) return Err_diffbytepersec;
    if(wd1->blocksize != wd2->blocksize) return Err_diffblocksize;
    if(wd1->bitpersmpl != wd2->bitpersmpl) return Err_diffbitpersmpl;
    return No_err;
}

/* WAV wd[] Ĥʤ file  header ν */
void putallWAVheader(FILE *file,WAVdata *wd,int N)
{
    int j;
    int datalen=0;

    writelittleito4byte(file,sto4bytelittlei("RIFF"));
    /* fputs("RIFF",file); */
    for(j=1;j<=N;j++) datalen+=wd[j-1].datalen;    
    writelittleito4byte(file,4+4+4+16+4+4+datalen);
    writelittleito4byte(file,sto4bytelittlei("WAVE"));
    writelittleito4byte(file,sto4bytelittlei("fmt "));
    writelittleito4byte(file,16);
    writelittleito2byte(file,wd[0].fmcode);
    writelittleito2byte(file,wd[0].channel);
    writelittleito4byte(file,wd[0].smplrate);
    writelittleito4byte(file,wd[0].bytepersec);
    writelittleito2byte(file,wd[0].blocksize);
    writelittleito2byte(file,wd[0].bitpersmpl);
    writelittleito4byte(file,sto4bytelittlei("data"));
    writelittleito4byte(file,datalen);
}


/*  ̤˻Ȥ */
/* file1 Υǡʬ file2 ˽񤭽Ф */
void putWAVdata(FILE *file1,FILE *file2,int pos,int len)
{
    int j;

    fseek(file1,pos,SEEK_SET);
    for(j=1;j<=len;j++)
      fputc(fgetc(file1),file2);
}


/* ########## 2byte, 4byte  data ɤ߹ ########## */
/* for WAV (little endian) */
int read4bytetolittlei(FILE *file,long int *J)
{
    static unsigned char s[5]={0,0,0,0,0};
    
    if(fread(s,4,1,file)<1) return Err_fread;
    *J=(s[3]<<24)|(s[2]<<16)|(s[1]<<8)|s[0];
    return No_err;
}

/* for WAV (little endian) */
int read2bytetolittlei(FILE *file,short int *J)
{
    static unsigned char s[5]={0,0,0,0,0};
    
    if(fread(s,2,1,file)<1) return Err_fread;
    *J=(s[1]<<8)|s[0];
    return No_err;
}

/* for WAV (little endian) */
void writelittleito4byte(FILE *file,unsigned long int n)
{
    fputc(n&0x00ff,file);
    fputc((n>>8)&0x00ff,file);
    fputc((n>>16)&0x00ff,file);
    fputc((n>>24)&0x00ff,file);
}

/* for WAV (little endian) */
void writelittleito2byte(FILE *file,unsigned short int n)
{
    fputc(n&0x00ff,file);
    fputc((n>>8)&0x00ff,file);
}

#endif /* __WAVIO_C__ */
